commit 5222017313f5abf39e2374dc11bcac9b444f1b4c
Author: Martin Liska <mliska@suse.cz>
Date:   Thu Jun 11 09:34:41 2020 +0200

    asan: fix RTX emission for ilp32
    
    gcc/ChangeLog:
    
            PR sanitizer/95634
            * asan.c (asan_emit_stack_protection): Fix emission for ilp32
            by using Pmode instead of ptr_mode.
    
    Co-Authored-By: Jakub Jelinek <jakub@redhat.com>
    (cherry picked from commit 8cff672cb9a132d3d3158c2edfc9a64b55292b80)

diff --git a/gcc/asan.c b/gcc/asan.c
index 4c99e3d9912..9014df19939 100644
--- a/gcc/asan.c
+++ b/gcc/asan.c
@@ -1480,6 +1480,7 @@ asan_emit_stack_protection (rtx base, rtx pbase, unsigned int alignb,
 	  mem = adjust_address (mem, ptr_mode, offset);
 	  rtx addr = gen_reg_rtx (ptr_mode);
 	  emit_move_insn (addr, mem);
+	  addr = convert_memory_address (Pmode, addr);
 	  mem = gen_rtx_MEM (QImode, addr);
 	  emit_move_insn (mem, const0_rtx);
 	}

